/* 
 * Copyright 1994 Alastair Gourlay
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice appear in all copies and that both that 
 * copyright notice and this permission notice appear in supporting 
 * documentation.
 */

/*
 *
 * BezelP.h - XmpBezel Private header
 *
 */

#ifndef _XmpBezelP_h
#define _XmpBezelP_h

#include "GeometryP.h"
#include "Bezel.h"

typedef struct
{
	XtPointer		extension;
} XmpBezelClassPart;

typedef struct _XmpBezelClassRec
{
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	XmManagerClassPart	manager_class;
	XmpGeometryClassPart	geometry_class;
	XmpBezelClassPart	bezel_class;
} XmpBezelClassRec;

externalref XmpBezelClassRec xmpBezelClassRec;

typedef struct
{
	Dimension		bezel_thickness;
	Dimension		margin_thickness;
} XmpBezelPart, *XmpBezelPartPtr;

typedef struct _XmpBezelRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
	XmpGeometryPart		geometry;
	XmpBezelPart		bezel;
} XmpBezelRec;

typedef struct _XmpBezelConstraintPart
{
	XtPointer		reserved;
} XmpBezelConstraintPart, *XmpBezelConstraintPartPtr;

typedef struct _XmpBezelConstraintRec
{
	XmManagerConstraintPart		manager;
	XmpGeometryConstraintPart	geometry;
	XmpBezelConstraintPart		bezel;
} XmpBezelConstraintRec, *XmpBezelConstraint;


/* Instance field access macros */

#define BezelThickness(w) (w->bezel.bezel_thickness)
#define MarginThickness(w) (w->bezel.margin_thickness)

#define ShadowThickness(w) (w->manager.shadow_thickness)
#define TopShadowGC(w) (w->manager.top_shadow_GC)
#define BottomShadowGC(w) (w->manager.bottom_shadow_GC)

/* Constraint field access macros */

#define BezelConstraint(w) ((XmpBezelConstraint)(w->core.constraints))

#define BezelReserved(w) (BezelConstraint(w)->bezel.reserved)

#endif /* _XmpBezelP_h */
