/* 
 * Copyright 1994 Alastair Gourlay
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice appear in all copies and that both that 
 * copyright notice and this permission notice appear in supporting 
 * documentation.
 */

/*
 *
 * Caption.h - XmpCaption Public header
 *
 */

#ifndef _XmpCaption_h
#define _XmpCaption_h

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef XmpIsCaption
#define XmpIsCaption(w) XtIsSubclass(w, xmpCaptionWidgetClass)
#endif

#define XmNstretchHorizontal "stretchHorizontal"
#define XmCStretchHorizontal "StretchHorizontal"
#define XmNstretchVertical "stretchVertical"
#define XmCStretchVertical "StretchVertical"
#define XmNcaptionAlignment "captionAlignment"
#define XmCCaptionAlignment "CaptionAlignment"
#define XmRCaptionAlignment "CaptionAlignment"
#define XmNcaptionJustify "captionJustify"
#define XmCCaptionJustify "CaptionJustify"
#define XmRCaptionJustify "CaptionJustify"
#define XmNstrechControl "strechControl"
#define XmCStrechControl "StrechControl"

enum { XmCAPTION_TOP=0, XmCAPTION_CENTER=1, XmCAPTION_BOTTOM=2 };
enum { XmJUSTIFY_LEFT=0, XmJUSTIFY_RIGHT=1 };

externalref WidgetClass xmpCaptionWidgetClass;

typedef struct _XmpCaptionClassRec *XmpCaptionWidgetClass;
typedef struct _XmpCaptionRec *XmpCaptionWidget;

#ifdef _NO_PROTO

extern Widget XmpCreateCaption();

#else

extern Widget XmpCreateCaption(Widget, char*, Arg*, Cardinal);

#endif /* _NO_PROTO */

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmpCaption_h */

