/* 
 * Copyright 1994 Alastair Gourlay
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice appear in all copies and that both that 
 * copyright notice and this permission notice appear in supporting 
 * documentation.
 */

/*
 *
 * GridP.h - XmpGrid Private header
 *
 */

#ifndef _XmpGridP_h
#define _XmpGridP_h

#include "GeometryP.h"
#include "Grid.h"

typedef struct
{
	XtPointer		extension;
} XmpGridClassPart;

typedef struct _XmpGridClassRec
{
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	XmManagerClassPart	manager_class;
	XmpGeometryClassPart	geometry_class;
	XmpGridClassPart	grid_class;
} XmpGridClassRec;

externalref XmpGridClassRec xmpGridClassRec;

typedef struct
{
	Dimension		margin_width;
	Dimension		margin_height;
	short			rows;
	short			columns;
} XmpGridPart, *XmpGridPartPtr;

typedef struct _XmpGridRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
	XmpGeometryPart		geometry;
	XmpGridPart		grid;
} XmpGridRec;

typedef struct _XmpGridConstraintPart
{
	Dimension		grid_margin_width;
	Dimension		grid_margin_height;
} XmpGridConstraintPart, *XmpGridConstraintPartPtr;

typedef struct _XmpGridConstraintRec
{
	XmManagerConstraintPart		manager;
	XmpGeometryConstraintPart	geometry;
	XmpGridConstraintPart		grid;
} XmpGridConstraintRec, *XmpGridConstraint;


/* Instance field access macros */

#define MarginWidth(w) (w->grid.margin_width)
#define MarginHeight(w) (w->grid.margin_height)
#define Rows(w) (w->grid.rows)
#define Columns(w) (w->grid.columns)

/* Constraint field access macros */

#define GridConstraint(w) ((XmpGridConstraint)(w->core.constraints))

#define GridMarginWidth(w) (GridConstraint(w)->grid.grid_margin_width)
#define GridMarginHeight(w) (GridConstraint(w)->grid.grid_margin_height)

#endif /* _XmpGridP_h */
