/*
 *
 * TemplateP.h - XmpTemplate Private header
 *
 */

#ifndef _XmpTemplateP_h
#define _XmpTemplateP_h

#include "GeometryP.h"
#include "Template.h"

typedef struct
{
	XtPointer		extension;
} XmpTemplateClassPart;

typedef struct _XmpTemplateClassRec
{
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	ConstraintClassPart	constraint_class;
	XmManagerClassPart	manager_class;
	XmpGeometryClassPart	geometry_class;
	XmpTemplateClassPart	template_class;
} XmpTemplateClassRec;

externalref XmpTemplateClassRec xmpTemplateClassRec;

typedef struct
{
	int			template_resource;
} XmpTemplatePart, *XmpTemplatePartPtr;

typedef struct _XmpTemplateRec
{
	CorePart		core;
	CompositePart		composite;
	ConstraintPart		constraint;
	XmManagerPart		manager;
	XmpGeometryPart		geometry;
	XmpTemplatePart		template;
} XmpTemplateRec;

typedef struct _XmpTemplateConstraintPart
{
	int			template_constraint_resource;
} XmpTemplateConstraintPart, *XmpTemplateConstraintPartPtr;

typedef struct _XmpTemplateConstraintRec
{
	XmManagerConstraintPart		manager;
	XmpGeometryConstraintPart	geometry;
	XmpTemplateConstraintPart	template;
} XmpTemplateConstraintRec, *XmpTemplateConstraint;


/* Instance field access macros */

#define TemplateResource(w) (w->template.template_resource)

/* Constraint field access macros */

#define TemplateConstraint(w) ((XmpTemplateConstraint)(w->core.constraints))

#define TemplateConstraintResource(w) \
	(TemplateConstraint(w)->template.template_constraint_resource)

#endif /* _XmpTemplateP_h */
